=pod

Module O_P.pm

A component of the checker group of programs for monitoring applications, databases, networks, 
all types of servers, and more. By Nova Software, Inc. 

Copyright  by Nova Software, Inc. 2018  All rights reserved.  http://www.nova-sw.com

=cut
  package O_P ; our $VERSION = 0.180506; use strict; use warnings; use sigtrap; use O_B 0.170824; use O_M 0.170824; use O_U 0.170824;
use O_L 0.170824; use O_C 0.171001; use O_T 0.171001; use O_R 0.170824; use File::Copy; use File::Basename; use Time::Local; use Data::Dumper;  my $pyP = enB; my $tlP = nxB; my $iwP = vgB; my $mcP = rnB; BEGIN { use Exporter (); our @ISA = qw(Exporter); our @EXPORT = qw( zvP hmP ); }
{  my $n2P;  my $ntP;  my $ypP;  my $pxP; sub vnP { my $cbP = shift;  my ($ooP, $dwP, $xkP, $zqP, $qsP) = (localtime(time()))[2..6] ; defined $n2P or $n2P = $ooP;  defined $ntP or $ntP = $qsP;  defined $ypP or $ypP = 1;  defined $pxP or $pxP = $xkP;  my $bdP = '';  if ($ooP < $n2P)  {  $bdP = tkP($cbP, $qsP, $xkP) ; } $n2P = $ooP; $ntP = $qsP; $ypP++;  $pxP = $xkP ;
return $bdP;  } sub tkP { my ($cbP, $qsP, $xkP) = @_;  my $jwP = 0;  if ($cbP == 1)  { $jwP = 1 ; }         elsif ($cbP == 5) { $jwP = 1  if ($qsP == 1 or $qsP == 6 ) ;   } elsif ($cbP == 7) { $jwP = 1  if $qsP == 0;  } elsif ($cbP == 14){ $ypP++ if  $qsP == 0 ;  if ( $ypP == 3 ) {  $jwP = 1;  $ypP = 1;  }
} elsif ($cbP == 28) { $ypP++ if  $qsP == 0 ;  if ( $ypP == 5 ) {  $jwP = 1;  $ypP = 1;  } } elsif ($cbP == 30){ $jwP = 1  if $xkP != $pxP;  } elsif ($cbP == 90) { $jwP = 1 if ( $xkP != $pxP  and (   $xkP == 0   or $xkP == 3  or $xkP == 6  or $xkP == 9 )  ); }
return $jwP;  } } {  my $spP = 0; my $iiP = 0; my $dtP = localtime(time()); sub zvP { my ($pgP, $kzP, $coP ) = @_;  my $cbP = taC(qjB, 'reportperiod');   my $fdP = 0; if ($cbP) {  $fdP = vnP($cbP); $fdP = $fdP or restart_reportperiod() ;   } $dtP = localtime(time())  if $fdP;  my $duP = taC(q1B, '_no_dflt_mail') && taC(q1B, '_no_dflt_syslog') ? cwM(140, taC(q1B, 'abslogfilepath')) : ""; my $plP = (time() - vvB())/(60*60);
my $mwP = cwM(141, sprintf("%.3f", $plP), cfB().$duP); $mwP .= "\n".vzM.cwM(183, riB(), $coP, bhB() )  if $coP; my $bdP = "$mwP\n";  my $q4P = taC(qjB, 'absstatusfilepath'); if ( not taC(qjB, 'statuson') and -f $q4P) {  unlink $q4P or wmL(dyM(38, $q4P, $!)); } my $jkP = taC(qjB, 'absgroupstatusfilepath');  my $l5P = srC(); my $ngP = scalar keys %$l5P and taC(qjB, 'groupstatuson'); if ( not $ngP and -f $jkP) {  unlink $jkP or wmL(dyM(38, $jkP, $!)); } if (($kzP - $spP) >= taC(qjB, 'statusupdate')) {  $bdP .= gbP($pgP, $kzP, $mwP)  if taC(qjB, 'statuson'); chomp $bdP; chomp $bdP; $bdP .= koP($pgP, $kzP, $mwP) if $ngP ; chomp $bdP;
$spP = $kzP; } my $jtP = taC(qjB, 'absuptimefilepath'); my $u4P = taC(qjB, 'absgroupuptimefilepath'); my $pmP = (keys %$l5P) and taC(qjB, 'groupuptimeon'); qpP($jtP) if ( not taC(qjB, 'uptimeon') and -f $jtP ) ; qpP($u4P) if ( not $pmP and -f $u4P ) ; my $khP = taC(qjB, 'uptimeupdate');  if ((($kzP - $iiP) >= $khP)) { if ( taC(qjB, 'uptimeon') ) { qpP($jtP)  if $fdP;  $bdP .= aoP($pgP, $kzP, $mwP); chomp $bdP; chomp $bdP; } if ( taC(qjB, 'groupuptimeon') ) {  qpP($u4P)  if $fdP;  cxP($pgP, $kzP, $mwP) if $pmP; } $iiP = $kzP;
} $pgP = undef;  return ($bdP, $fdP); } sub gbP {       my ($pgP, $kzP, $mwP) = @_; my $yqP = qbC(); $yqP ||= a1B;  my $uqP = time; my %wdP = ( $iwP => 0, $tlP => 0, $pyP => 0); my $i3P = ocP('STATUS', $uqP, $mwP) ; my %fuP = (); foreach my $rqP (sort keys %$pgP) {  next if ($rqP eq q1B or $rqP eq qjB); next if $pgP->{$rqP}{hostrange};  next if $pgP->{$rqP}{nolicense};  my $fzP = localtime $uqP; my $xrP = 0; my $rsP = $pyP; my $pvP = qeT($rqP);
my $miP = qeT("[poll_time]$rqP"); if ( $miP > 0)  {  $fzP = localtime $miP; my $avP = ref $pvP->[-1] ? -2 : -1; $xrP = ($miP - abs $pvP->[$avP])/3600; $rsP = $pvP->[$avP] < 0 ? $tlP : $iwP; } elsif (ref $pvP->[-1] ) { $xrP = ($uqP - abs $pvP->[-1][0])/3600; $rsP = $pyP; } else { urL(dyM(41, "'[poll_time]$rqP' = '$miP' but not ".'ref $pvP->[-1]')); $rsP = $mcP; } $wdP{$rsP}++; my $reP = substr ikB($pgP->{$rqP}{criticality}), 0, 1; push @{$fuP{$rsP}}, "$reP\t".sprintf("%-*s", $yqP,$rqP) ."\t".sprintf("%8s", $rsP) ."\t".sprintf("%8.3f", $xrP)
."\thours as of\t$fzP\n" ; } my @rxP = (); foreach my $rsP (sort keys %fuP) {  push @rxP, sort {vkP()} @{$fuP{$rsP}}; } my $vcP = "\nTotals:  \t$wdP{$tlP} down  \t$wdP{$pyP} no checking  \t$wdP{$iwP} up  \tafter loop $kzP\t\n\n"; unshift @rxP, $i3P, $vcP; push @rxP, '_' x 100, "\n\n" ; my $izP = qmU (taC(qjB, 'absstatusfilepath'), @rxP); shL($izP) if $izP; $pgP = undef;  return $vcP; } sub koP {       my ($pgP, $kzP, $mwP) = @_; my $yqP = ayC(); $yqP ||= ldB;  my $uqP = time; my %wdP = ( $iwP => 0, $tlP => 0, $pyP => 0);
my $i3P = ocP('GROUP STATUS', $uqP, $mwP) ; my %fuP = (); my $muP = srC(); foreach my $eiP (sort keys %$muP) {  next if $eiP =~/:criticality$/; my $fzP = localtime $uqP; my $xrP = 0; my $rsP = $pyP; my $pvP = grp_qeT($eiP); my $miP = grp_qeT("[poll_time]$eiP"); if ( $miP > 0)  {  $fzP = localtime $miP; my $avP = ref $pvP->[-1] ? -2 : -1; $xrP = ($miP - abs $pvP->[$avP])/3600; $rsP = $pvP->[$avP] < 0 ? $tlP : $iwP; } elsif (ref $pvP->[-1] ) { $xrP = ($uqP - abs $pvP->[-1][0])/3600; $rsP = $pyP; }
else { urL(dyM(43, "'[poll_time]$eiP' = '$miP' but not ".'ref $pvP->[-1]')); $rsP = $mcP; } $wdP{$rsP}++; my $reP = substr $muP->{"$eiP:criticality"}, 0, 1; push @{$fuP{$rsP}}, "$reP\t".sprintf("%-*s", $yqP,$eiP) ."\t".sprintf("%8s", $rsP) ."\t".sprintf("%8.3f", $xrP) ."\thours as of\t$fzP\n" ; } my @rxP = (); foreach my $rsP (sort keys %fuP) {  push @rxP, sort {vkP()} @{$fuP{$rsP}}; } my $vcP = "\nTotals:  \t$wdP{$tlP} down  \t$wdP{$pyP} no checking  \t$wdP{$iwP} up  \tafter loop $kzP\t\n\n"; unshift @rxP, $i3P, $vcP; push @rxP, cwM(304, 'somefile'), '_' x 100, "\n\n" ; my $izP = qmU (taC(qjB, 'absgroupstatusfilepath'), @rxP); shL($izP) if $izP;
$pgP = undef;  return $vcP; } my $baP; my $ksP; my $l1P; my $vaP; sub aoP { my ($pgP, $kzP, $mwP) = @_; my $yqP = qbC(); $yqP ||= a1B;  my $uqP = time; my $i3P = ocP('UPTIME', $uqP, $mwP);  my @rxP = (); my ($jbP, $saP, $o2P, $axP, $arP) = (0,0,0,0,0); foreach my $rqP (sort keys %$pgP) {  next if ($rqP eq q1B or $rqP eq qjB); next if $pgP->{$rqP}{hostrange};  next if $pgP->{$rqP}{nolicense};  $axP++;
next if taC($rqP, 'nouptime'); $arP++; my @ezP = @{qeT($rqP)};  my $quP = $ezP[0]; $quP = $quP->[0] if ref $quP; $quP = abs $quP; urL(dyM(71, 'aoP', $quP, $rqP ) ) unless defined $quP; my $tmp = qeT("[poll_time]$rqP") ; my $miP = $tmp ? abs $tmp : 1 ;  my $pfP = 1; $pfP = ($miP - $quP) if $quP; my ($tnP, $fyP, $ogP) = (0,0,0); xeP(\$tnP, \$fyP);   my $fpP = 0;  while (@ezP) { my $umP = shift @ezP; if (ref $umP) {  haP($umP->[0], $fpP) if $fpP; if (@$umP == 2) { $ogP += abs($umP->[1]) - abs($umP->[0]);
$fpP = 0;  } elsif(@$umP == 1) {  $ogP += $miP - abs($umP->[0]); my $akP = @ezP; urL(dyM(72, 'aoP', $akP)) if $akP; } else { my $ouP = @$umP; urL(dyM(73, 'aoP', $ouP )); } } else {  haP($umP, $fpP) if $fpP; haP($miP, $umP) unless @ezP;  $fpP = $umP; } } my $reP = substr ikB($pgP->{$rqP}{criticality}), 0, 1; my $tgP = $pfP - $ogP;
$jbP += $tnP; $saP += $fyP; $o2P += $tgP; $tgP ||= 1;  push @rxP, "$reP\t".sprintf("%-*s", $yqP,$rqP) ."\t".sprintf("%8.2f", 100*$tnP/$tgP)."% $iwP" ."\t".sprintf("%8.2f", 100*$fyP/$tgP)."% $tlP" ."\tfor ".sprintf("%8.3f", ( $pfP - $ogP)/3600 ).' hrs. = (' .sprintf("%8.3f", $pfP/3600) ." - ".sprintf("%8.3f", $ogP/3600)." $pyP)" ."\tfrom ".localtime ($quP) ."\tto ".localtime ($miP)."\n" ; } @rxP = sort {vkP()} @rxP;  $o2P ||= 1;  defined $baP or $baP = $axP;  defined $ksP or $ksP = $axP; $baP = $axP if $axP > $baP; $ksP = $axP if $axP < $ksP; my $vyP = taC($Dcmnt::Setup, 'staticconfig')
? '' : cwM(143, $baP, $ksP, 'targets')  ; my $bsP =  "\n\nAverages: " ."\t".sprintf("%8.2f", 100* $jbP/$o2P)."% $iwP" ."\t".sprintf("%8.2f", 100*$saP/$o2P)."% $tlP" ."\tfor $arP reportable targets " ."\tafter loop $kzP" .$vyP ."\n\n"; unshift @rxP, $i3P, $bsP; push @rxP, cwM(142), '_' x 100, "\n\n";   qmU (taC(qjB, 'absuptimefilepath'), @rxP); $pgP = undef;  return $bsP; }  sub cxP { my ($pgP, $kzP, $mwP) = @_; my $yqP = qbC(); $yqP ||= ldB;  my $uqP = time;
my $i3P = ocP('GROUP UPTIME', $uqP, $mwP);  my @rxP = (); my ($jbP, $saP, $o2P, $oiP, $hbP) = (0,0,0,0,0); my $muP = srC(); foreach my $eiP (sort keys %$muP) {  next if $eiP =~/:criticality$/; $oiP++; my $ebP = 0; foreach my $rqP (@{$muP->{$eiP}}) { $ebP = 1   if taC($rqP, 'nouptime'); $ebP = 1   if taC($rqP, 'nolicense');   } next if $ebP;  $hbP++; my @ezP = @{grp_qeT($eiP)};  my $quP = $ezP[0]; $quP = $quP->[0] if ref $quP; $quP = abs $quP; urL(dyM(71, 'cxP', $quP, $eiP ) ) unless defined $quP; my $tmp = grp_qeT("[poll_time]$eiP") ;
my $miP = $tmp ? abs $tmp : 1 ;  my $pfP = 1; $pfP = ($miP - $quP) if $quP; my ($tnP, $fyP, $ogP) = (0,0,0); xeP(\$tnP, \$fyP);   my $fpP = 0;  while (@ezP) { my $umP = shift @ezP; if (ref $umP) {  haP($umP->[0], $fpP) if $fpP; if (@$umP == 2) { $ogP += abs($umP->[1]) - abs($umP->[0]); $fpP = 0;  } elsif(@$umP == 1) {  $ogP += $miP - abs($umP->[0]); my $akP = @ezP; urL(dyM(72, 'cxP', $akP)) if $akP; } else {
my $ouP = @$umP; urL(dyM(73, 'cxP', $ouP )); } } else {  haP($umP, $fpP) if $fpP; haP($miP, $umP) unless @ezP;  $fpP = $umP; } } my $reP = substr $muP->{"$eiP:criticality"}, 0, 1; my $tgP = $pfP - $ogP; $jbP += $tnP; $saP += $fyP; $o2P += $tgP; $tgP ||= 1;  push @rxP, "$reP\t".sprintf("%-*s", $yqP,$eiP) ."\t".sprintf("%8.2f", 100*$tnP/$tgP)."% $iwP" ."\t".sprintf("%8.2f", 100*$fyP/$tgP)."% $tlP" ."\tfor ".sprintf("%8.3f", ( $pfP - $ogP)/3600 ).' hrs. = ('
.sprintf("%8.3f", $pfP/3600) ." - ".sprintf("%8.3f", $ogP/3600)." $pyP)" ."\tfrom ".localtime ($quP) ."\tto ".localtime ($miP)."\n" ; } @rxP = sort {vkP()} @rxP;  $o2P ||= 1;  defined $l1P or $l1P = $oiP;  defined $vaP or $vaP = $oiP; $l1P = $oiP if $oiP > $l1P; $vaP = $oiP if $oiP < $vaP; my $vyP = taC($Dcmnt::Setup, 'staticconfig') ? '' : cwM(143, $l1P, $vaP, 'groups')  ; my $bsP =  "\n\nAverages: " ."\t".sprintf("%8.2f", 100* $jbP/$o2P)."% $iwP" ."\t".sprintf("%8.2f", 100*$saP/$o2P)."% $tlP" ."\tfor $hbP reportable groups " ."\tafter loop $kzP" .$vyP
."\n\n"; unshift @rxP, $i3P, $bsP; push @rxP, cwM(304, 'somefile') ; push @rxP, cwM(142), '_' x 100, "\n\n";   my $izP = qmU (taC(qjB, 'absgroupuptimefilepath'), @rxP); print "$izP\n" if $izP;  $pgP = undef;  return $bsP; }  sub ocP { my ($maP, $uqP, $mwP) = @_; my $zbP = localtime($uqP) ;  my $jcP = caC(); my $vyP = $jcP ? "\n".d1M.cwM(314, $jcP) : ''; cwM(90, $maP, APP_N_HOST(), kqM( taC(qjB, 'reportperiod') ),  $dtP, "$zbP", yfB(), azR(), skB(), $$     )."$vyP$mwP\n"; } {  my ($lyP, $amP) = ('','');
sub xeP { $lyP = shift; $amP = shift; } sub haP { my ($a3P, $wrP) = @_; unless ($a3P and $wrP) { urL(dyM(45, $a3P, $wrP)); return; } my $tmp = abs($a3P) - abs($wrP); $$lyP += $tmp if $wrP > 0; $$amP += $tmp if $wrP < 0; } }  }  gxU('O_T');  sub qpP { my $maP = shift;  my $tmp = bpU();
my $tmp1 = ycB; my $auP = $maP; $auP =~s/$tmp1$/$tmp\.$tmp1/; my $daP = move($maP, $auP); if ($daP) { shL(dyM(39, $auP)); } else { wmL(dyM(40, $maP, $auP, $!)); } } sub hmP { snP(@_) } sub snP { my $dhP = shift;  my ($xnP, $nuP, $zjP)  = fileparse(taC(qjB, 'uptimefilepath') ); opendir CUDH, $nuP or wmL cwM(177, $nuP, $!) and return ; my @xoP = readdir CUDH or wmL cwM(178, $nuP, $!) and return ; foreach my $mjP (@xoP) { next unless $mjP =~/$xnP\.\d{10}/; my $ujP = $nuP.xhB().$mjP; 
my $qyP = (stat $ujP )[9]; my $dmP = int ( (time() - $qyP)/(60*60*24) ) ; unlink $ujP  or wmL cwM(36, $ujP, $!)  if $dmP > taC(qjB, 'uptimefilesage');   }    } sub vkP { my $nlP = substr($a,0,1); my $vuP = substr($b,0,1); my $bdP = $nlP cmp $vuP;   $bdP = -$bdP if ($nlP =~/[LM]/ and $vuP =~/[LM]/); return $bdP; } sub END{} 1;
__DATA__
Mv7rMiKP7xmS742NvHGjqw

